%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Implementation of library Float

:- use_module(prim_standard).

?- block prim_Float_plus(?,?,?,-,?).
prim_Float_plus(RA,RB,R,E0,E) :-
	hnf(RA,A,E0,E1), hnf(RB,B,E1,E2), prim_arithbinop_exec(A,B,A+B,R,E2,E).

?- block prim_Float_minus(?,?,?,-,?).
prim_Float_minus(RA,RB,R,E0,E) :-
	hnf(RA,A,E0,E1), hnf(RB,B,E1,E2), prim_arithbinop_exec(A,B,A-B,R,E2,E).

?- block prim_Float_times(?,?,?,-,?).
prim_Float_times(RA,RB,R,E0,E) :-
	hnf(RA,A,E0,E1), hnf(RB,B,E1,E2), prim_arithbinop_exec(A,B,A*B,R,E2,E).

?- block prim_Float_div(?,?,?,-,?).
prim_Float_div(RA,RB,R,E0,E) :-
	hnf(RA,A,E0,E1), hnf(RB,B,E1,E2), prim_arithbinop_exec(A,B,A/B,R,E2,E).

% transform an integer into a float:
?- block prim_i2f(?,?,-,?).
prim_i2f(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,A*1.0,R,E1,E).

% transform a float to an integer:
?- block prim_truncate(?,?,-,?).
prim_truncate(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,integer(A),R,E1,E).

% round a float to an integer:
?- block prim_round(?,?,-,?).
prim_round(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,integer(round(A)),R,E1,E).

?- block prim_sqrt(?,?,-,?).
prim_sqrt(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,sqrt(A),R,E1,E).

?- block prim_log(?,?,-,?).
prim_log(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,log(A),R,E1,E).

?- block prim_exp(?,?,-,?).
prim_exp(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,exp(A),R,E1,E).

?- block prim_sin(?,?,-,?).
prim_sin(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,sin(A),R,E1,E).

?- block prim_cos(?,?,-,?).
prim_cos(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,cos(A),R,E1,E).

?- block prim_tan(?,?,-,?).
prim_tan(RA,R,E0,E) :-
	hnf(RA,A,E0,E1), prim_arithunop_exec(A,tan(A),R,E1,E).
